unit hiFormHideShow;

interface

uses Kol,Share,Messages,Windows,Debug;

type
  THIFormHideShow = class(TDebug)
   private
    FCount:integer;
    FDec:integer;
    FHandle:integer;

    FTimer:PTimer;
    procedure SetAttr(h:THandle; CValue:TColor; AValue:byte; Flag:DWORD);
    procedure SetEnable(Value:boolean);
    procedure OnTime(Obj:PObj);
   public
    _prop_Show:integer;
    _prop_Hide:integer;
    _prop_Close:byte;

    _data_Handle:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doShow(var _Data:TData; Index:word);
    procedure _work_doHide(var _Data:TData; Index:word);
    procedure _work_doClose(var _Data:TData; Index:word);
  end;

implementation

procedure THIFormHideShow.SetAttr;
const
  LWA_ALPHA=$00000002;
  WS_EX_LAYERED=$00080000;
type
  TSetLayeredWindowAttributes=
    function( hwnd: Integer; crKey: TColor; bAlpha: Byte; dwFlags: DWORD )
    : Boolean; stdcall;
var
  SetLayeredWindowAttributes: TSetLayeredWindowAttributes;
  User32: THandle;
  dw: DWORD;
begin
  User32 := GetModuleHandle( 'User32' );
  SetLayeredWindowAttributes := GetProcAddress( User32, 'SetLayeredWindowAttributes' );
  if Assigned( SetLayeredWindowAttributes ) then
   begin
    dw := GetWindowLong( h, GWL_EXSTYLE );
    SetWindowLong( h, GWL_EXSTYLE, dw or WS_EX_LAYERED );
    SetLayeredWindowAttributes( h, CValue, AValue and $FF, Flag);
   end;
end;

constructor THIFormHideShow.Create;
begin
   inherited Create;
   FTimer := NewTimer(20);
   FTimer.Enabled := false;
   FTimer.OnTimer := onTime;
end;

destructor THIFormHideShow.Destroy;
begin
   FTimer.Free;
   inherited Destroy;
end;

procedure THIFormHideShow.SetEnable;
begin
   FTimer.Enabled := Value;
end;

procedure THIFormHideShow.onTime;
var x,i:real;
const LWA_ALPHA=$00000002;
begin
    i:=FCount;
    if FDec=1 then
      begin
      x:=10000/_prop_Show;
        i:=i+x;
        if i<255 then
          begin
            FCount:=round(i);
          end else
          begin
            FCount:=255;
            FTimer.Enabled := false;
          end;
          SetAttr(FHandle,0,FCount,LWA_ALPHA);
      end else
      begin
      x:=10000/_prop_Hide;
        i:=i-x;
        if i>0 then
          begin
            FCount:=round(i);
            SetAttr(FHandle,0,FCount,LWA_ALPHA);
          end else
          begin
            FCount:=0;
            FTimer.Enabled := false;
            SetAttr(FHandle,0,FCount,LWA_ALPHA);
            if _prop_Close=1 then PostMessage(FDec, WM_QUIT, 0, 0);
          end;

      end;
end;

procedure THIFormHideShow._work_doShow;
begin
      FCount:=0;
      FDec:=1;
      FHandle:=ReadInteger(_Data,_data_Handle,0);
      FTimer.Enabled := true;
end;

procedure THIFormHideShow._work_doHide;
begin
      FCount:=255;
      FDec:=0;
      FHandle:=ReadInteger(_Data,_data_Handle,0);
      FTimer.Enabled := true;
end;

procedure THIFormHideShow._work_doClose;
begin
  PostMessage(ReadInteger(_Data,_data_Handle,0), WM_QUIT, 0, 0);
end;

end.
